diff -r c7fa5cfef08f mailtrain.c
--- a/mailtrain.c	Wed Mar 05 13:48:46 2008 +0100
+++ b/mailtrain.c	Wed Mar 05 13:50:54 2008 +0100
@@ -125,6 +125,7 @@
 	int fd;
 	char *buf;
 	enum classification wanted;
+	int rc = 0;
 
 	t_push();
 
@@ -141,13 +142,15 @@
 		if (run_sendmail(fd, wanted)) {
 			mail_storage_set_error(ctx->box->storage,
 					       "failed to send mail");
-			return -1;
+			debug("run program failed with exit code %d\n", rc);
+			rc = -1;
+			break;
 		}
 	}
 
 	t_pop();
 
-	return 0;
+	return rc;
 }
 
 static void clear_tmpdir(struct antispam_transaction_context *ast)
